<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Erfassung des Antwortverhaltens: 
* (1) Verweildauer pro Seite
* (2) Uhrzeit
* (3) Vor/Zurck/Sprung Navigation
* (4) Sicherheit

*/
class Log {
		
	private $blockcount = 30;

	function __construct(){
		global $_POST,$_SERVER, $__FILE, $__PAGE; 
		if( ! mysql_query( "select * from ".LOG_DATABASE, DB_HANDLE ) ) $this->createTable();
	}

	function block(){
		global $_POST,$_SERVER,$__LOGMODE,$__AUTHENTICATION, $__AUTHENTICATIONMODE;
		if( $__AUTHENTICATIONMODE == "open" || $__AUTHENTICATIONMODE == "poll" || $__AUTHENTICATIONMODE == "cookie" ) return;
		//$ip = $_SERVER["REMOTE_ADDR"];
		$ip = Log::getIP();
		$result = mysql_query( "select n from ".LOG_DATABASE." where ip=\"".$ip."\" AND status!=0", DB_HANDLE ) or die( "select log ".mysql_error() );
		if( $result ){
			if( mysql_num_rows( $result ) > $this->blockcount ){
				require( "security_error.html" );
				die();
			}
		}
	}

	function write($additonal = ""){
		global $_GET,$_POST,$_SERVER,$__ERROR,$__PAGE,$__REQUEST_PAGE,$__LOGMODE;
		$agent = "";
		if(isset($_SERVER['HTTP_USER_AGENT'])) $agent = $_SERVER['HTTP_USER_AGENT'];
		
		$requestpage = intval(mysql_real_escape_string($__REQUEST_PAGE));
		$writepage = intval(mysql_real_escape_string($__PAGE));
		$advanced = mysql_real_escape_string($agent);
		if(strlen($additonal)>0) $advanced .= "|".mysql_real_escape_string($additonal);
		$post = "";
		if($__LOGMODE == "verbose"){
			$post = mysql_real_escape_string(Log::array2string( $_POST ));
		}
		$get = mysql_real_escape_string(Log::array2string($_GET));
		
		$requesttime = -9;
		if(isset($_POST["__timestamp"])) $requesttime = mysql_real_escape_string($_POST["__timestamp"]);
		$writetime = time();
		
		$status = intval($__ERROR);
		$ip = "-";
		if( $status != ERROR_OK ){
			$ip = mysql_real_escape_string( Log::getIP() );
			//$ip = mysql_real_escape_string($_SERVER["REMOTE_ADDR"]);
		}

		mysql_query( "insert into ".LOG_DATABASE." (requestpage,writepage,requesttime,writetime,status,ip,get,post,advanced ) 
			values ($requestpage,$writepage,$requesttime,$writetime,$status,\"{$ip}\",\"{$get}\",\"{$post}\",\"{$advanced}\")", DB_HANDLE ) or die( "error: Log::write() ".mysql_error() );
	}

	function createTable(){
		$vars = array();
		array_push( $vars, "n INT PRIMARY KEY NOT NULL AUTO_INCREMENT" );
		array_push( $vars, "requestpage INT" );
		array_push( $vars, "writepage INT" );
		
		array_push( $vars, "requesttime INT" );
		array_push( $vars, "writetime INT" );
		
		array_push( $vars, "status INT" );
		array_push( $vars, "ip VARCHAR(20)" );
		
		array_push( $vars, "get TEXT" );
		array_push( $vars, "post TEXT" );
		
		array_push( $vars, "advanced TEXT" );
		mysql_query( "create table ".LOG_DATABASE." (".join(", ", $vars ).") ", DB_HANDLE ) or die( "error: Log::createDatabase() ".mysql_error() );
	}

	function deleteTable(){
		mysql_query( "drop table ".LOG_DATABASE." ", DB_HANDLE ) or die( "Log::deleteTable()" );
	}

	function updateTable(){
		$res = mysql_query( "show columns from ".LOG_DATABASE, DB_HANDLE );
		if( mysql_num_rows( $res ) > 0 ){
			while( $row = mysql_fetch_assoc( $res ) ) $names[$row["Field"]] = 1;
		}
		if( array_key_exists( "duration", $names ) ){
			$this->deleteTable();
			$this->createTable();
		}
		else if( array_key_exists( "writettime", $names ) ){
			$this->deleteTable();
			$this->createTable();
		}
	}

	function array2string( $arr ){
		$ser = "";
		foreach( $arr as $key => $val ) $ser .= "{{". $key ."==". $val."}}";
		return $ser;
	}

	static function getIP(){
		global $_SERVER;
		if( substr( ROOT_PATH, 0, 24 ) == "http://www.uni-kassel.de" ){
			list($ip1, $ip2) = split( ",", $_SERVER["HTTP_X_FORWARDED_FOR"] );
			return trim( $ip1 );
		}
		else return $_SERVER["REMOTE_ADDR"];
	}
}
?>