<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class FormFactory {
    static function create( $name ){
        switch( $name ){
            case "CV" :
                return new CV();
            break;

            case "MD" :
                return new MD();
            break;

            case "RE" :
                return new RE();
            break;
            
            case "HL" :
                return new HL();
            break;

            case "ME" :
                return new ME();
            break;

            case "TE" :
                return new TE();
            break;

            case "PIN" :
			    return new PIN();
            break;

            case "TL" :
                return new TL();
            break;

            case "OR" :
                return new ORD();
            break;

            case "XHTML" :
			    return new XHTML();
            break;

            case "RAW" :
			    return new RAW();
            break;

            case "Page" :
			    return new Page();
            break;

            case "NavigationButton" :
				return new NavigationButton();
            break;

            case "ProgressBar" :
				return new ProgressBar();
            break;

            case "IMAGE" :
				return new IMAGE();
            break;
            
            case "COLUMNCONTAINER" :
				return new COLUMNCONTAINER();
			break;
            
            case "Folder" :
				return new Folder();
            break;
            
			case "SNIPPET" :
				return new SNIPPET();
            break;
            
            case "SETUP" :
				return new SETUP();
            break;
            
			case "FINISH" :
				return new FINISH();
            break;
			
			case "CONTAINER" :
				return new CONTAINER();
            break;
			
			case "FormItem":
				return new CONTAINER();
			break;
        }
        return new RE();
    }
}
?>