<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* An Image
*
*
* <IMAGE>
* 	<imageid>XXX</imageid>
*	<size width="100" height="40" />
*   <position>center</position>
*	<data>[PNG-Data]</data>
* </IAMGE>
*
*/
class IMAGE extends FormItem {
	
	public $imageid = "emtpy";
	public $position = "left";

	function __construct(){
		parent::__construct();
		$this->type = "IMAGE";
		$this->formatterclass = "format/IMAGEFormatter";
		//$this->formatter = new IMAGEFormatter();
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){ 
			switch( $n ){

				case "imageid": 
					$this->imageid = $v; 
				break;

				case "position": 
					$this->position = $v; 
				break;
			}
		}
	}
}
?>