<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* The Progress Bar
*
* <ProgressBar type="bar" backgroundcolor="" color1="" color2="" />
*/
class ProgressBar extends FormItem {

	public $bartype = "numeric";
	public $backgroundcolor ="0000ff";
	public $color1 = "ff0000";
	public $color2 = "ffff00";
	public $size = 5;
	public $length = 200;

	function __construct(){
		parent::__construct();
		$this->type = "ProgressBar";
		$this->formatterclass = "ProgressBarFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		$att = $doc->attributes();
		if( isset( $att["type"] ) ) $this->bartype = $att["type"];
		if( isset( $att["backgroundcolor"] ) ) $this->backgroundcolor = $att["backgroundcolor"];
		if( isset( $att["color1"] ) ) $this->color1 = $att["color1"];
		if( isset( $att["color2"] ) ) $this->color2 = $att["color2"];
		if( isset( $att["size"] ) ) $this->size = $att["size"];
		if( isset( $att["length"] ) ) $this->length = $att["length"];
	}
}
?>