<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* PHP Code snippets 
*
* <SNIPPET href="resource.php" />
* 
*/
class SNIPPET extends FormItem {
	
	public $code = "";
	public $href = "";
	
	function __construct(){
		parent::__construct();
		$this->type = "SNIPPET";
		$this->formatterclass = "SNIPPETFormatter";
	}
	
	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){ 
			switch( $n ){
				case "code":
					$att = $v->attributes();
					if(isset($att["href"])) $this->href = $att["href"];
					else{
						$this->code = $v->asXML();
						$this->code = str_replace( "<code>", "", $this->code );
						$this->code = str_replace( "</code>", "", $this->code );
						$this->code = str_replace( "<![CDATA[", "", $this->code );
						$this->code = str_replace( "]]>", "", $this->code );
					}
				break;
			}
		}
	}
}

?>