<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Textinput element
*
* <TE>
*    <text>Question</text>
*    <subject></subject>
*    <variable></variable>
*    <size></size>
*    <prefilled>(please insert)</prefilled>
* </TE>
*/
class TE extends FormItem {

	public $length = 50;
	public $prefilled = "";
	public $otherref = array();

	function __construct(){
		parent::__construct();
		$this->type = "TE";
		$this->formatterclass = "TEFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){
			switch( $n ){
				case "size":
					$this->length = (int)$v;
				break;

				case "prefilled":
					$this->prefilled = $v;
				break;
			}
		}
	}
}
?>