<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
*/
class HLFormatter extends StandardFormatter {

    function before( &$quest ){
    	global $__DEBUG;
        $cols = 1;
        if( $quest->layout == "horizontal" ) $cols = $quest->childCount;

        print "<!-- start HLFormatter -->\n";
		print "<table width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td>\n";

		if( $__DEBUG ){
			print "<small>".$quest->id;
			if( count($quest->filter) > 0 ){
				print "<br/>filter:";
				foreach( $quest->filter as $ignore ){
					print $ignore["variable"]." ".$ignore["operator"]." ".$ignore["value"];
				}
			}
			print "</small>";
		}

		$l = $quest->level;
		//if( $l == "1" ) $l = "";
		if( mb_strlen( trim( $quest->text ) ) > 1 ){
			if( mb_strlen( trim( $quest->number ) ) > 0 ){
				print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"hl_head$l\">\n";
				print "    <tr>\n";
				print "        <td class=\"hl_nr$l\">".$quest->number."</td>\n";
				print "        <td class=\"hl_text$l\">".$quest->text."</td>\n";
				print "    </tr>\n";
				if( mb_strlen( trim( $quest->moretext ) ) > 0 ){
					print "    <tr>\n";
					print "        <td class=\"hl_more$l\" colspan=\"2\">".$quest->moretext."</td>\n";
					print "    </tr>\n";
				}
				print "</table>\n";
			}
			else{
				print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"hl_head$l\">\n";
				print "    <tr>\n";
				print "        <td class=\"hl_text$l\">".$quest->text."</td>\n";
				print "    </tr>\n";
				if( mb_strlen( trim( $quest->moretext ) ) > 0 ){
					print "    <tr>\n";
					print "        <td class=\"hl_more$l\" >".$quest->moretext."</td>\n";
					print "    </tr>\n";
				}
				print "</table>\n";
			}
		}
		else if( mb_strlen( trim( $quest->moretext ) ) > 0 ){
			print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"hl_head$l\">\n";
			print "    <tr>\n";
			print "        <td class=\"hl_more$l\" colspan=\"2\">".$quest->moretext."</td>\n";
			print "    </tr>\n";
			print "</table>\n";
		}

		print "		</td>\n";
		print "	</tr>\n";

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td>\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
        print "<!-- end HLFormatter -->\n";
    }

	function behind( &$quest ){
		print "<!-- start HLFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		print "<!-- end HLFormatter -->\n";
    }
}
?>