<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats PIN-Items
*
*/
class PINFormatter extends StandardFormatter {

    function before( &$quest ){
        global $__AUTHENTICATIONMODE, $_POST;
        
        $isRequest = false;
        
        if( isset( $_POST["__action"] ) ){
			if( $_POST["__action"] == "requestPIN" && $__AUTHENTICATIONMODE == "request") $isRequest = true;
        }
        
        $cols = 1;
        if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
        print "<!-- start PINFormatter -->\n";
        print "<div id=\"the_pin\">";
		print "<table width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"3\" cellspacing=\"0\">\n";
		print "    <tr>\n";
		print "        <td class=\"item".$quest->level."\" valign=\"top\">\n";
		print "            <table width=\"100%\"  cellpadding=\"5\" cellspacing=\"0\" >\n";
		print "                <tr>\n";
		print "                    <td class=\"item".$quest->level."\">\n";
		print $quest->text;
		print "                    </td>\n";
		print "                </tr>\n";
		
		if( $isRequest ){
			$newpin = User::requestPIN();
			print "<tr>";
			print "<td style=\"border:5px red solid;\" class=\"question1\">";
			print $quest->requestmessage." ".$newpin;
			if( strlen($quest->requesthelp) > 0 ){
				print "<br/>";
				print $quest->requesthelp;
			}
			print "</td>";
			print "</tr>";
		}
		
		print "                <tr>\n";
		print "                    <td class=\"item".$quest->level."\">\n";
		print "<qtafi:ERROR>\n";
		print "	<MESSAGE code=\"1\">".$quest->errormessage."</MESSAGE>\n";
		print "</qtafi:ERROR>\n";
		print $quest->moretext;
		//print " <qtafi:PIN /> <input type=\"submit\" onClick=\"document.qtafi2.__requestpage.value++;\" value=\"".$quest->buttonlabel."\" />\n";
		print " <qtafi:PIN /> <input type=\"submit\" onClick=\"document.qtafi2.__requestpage.value++;\" value=\"".$quest->buttonlabel."\" />\n";
		print "                    </td>\n";
		if( $__AUTHENTICATIONMODE == "request" && ! $isRequest ){
			print "                    <td>\n";
			print "<input value=\"".$quest->requestbuttonlabel."\" type=\"button\" onClick=\"requestPIN();\"></input>\n";
			print "                    </td>\n";
		}
		print "                </tr>\n";
		print "            </table>\n";
        print "<!-- end PINFormatter -->\n";
    }

    function between( &$quest, $i = 0 ){ }

    function behind( &$quest ){
        print "<!-- start PINFormatter -->\n";
	    print "        </td>\n";
	    print "    </tr>\n";
	    print "</table>\n";
	    print "</div>";
        print "<!-- end PINFormatter -->\n";
    }
}
?>