<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class ProjectFormatter extends StandardFormatter {

	function before( &$quest ){
		print "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
		//print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
		print "<!DOCTYPE html  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
		//print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";

		print "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\"\n";
		//print "xmlns:qtfi=\"http://localhost/qtafi3\">\n";
		print "xmlns:qtafi=\"http://localhost/qtafi3\" dir=\"".FormItem::$direction."\">\n";
		print "<head>\n";
		print "<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"></meta>\n";
		print "<meta name=\"generator\" content=\"online.QTAFI\"></meta>\n";
		print "<title>".TITLE." - ".PROJECT."</title>\n";
		print "<link rel=\"shortcut icon\"  href=\"".ROOT_PATH."/images/icon.png\"></link>\n";

		if( file_exists( PROJECT_PATH."style.css" ) ){
			//print "<style type=\"text/css\">\n";
			//include( PROJECT_PATH."style.css" );
			//print "</style>\n";
			//print "<link rel=\"stylesheet\" type=\"text/css\" href=\"".ONLINE_PROJECTS_PATH."/".PROJECT."/style.css\"></link>\n";
			print "<link rel=\"stylesheet\" type=\"text/css\" href=\"".ONLINE_PROJECTS_PATH."/".PROJECT."/".$quest->usestyle."\"></link>\n";
		}
		else{
			$style = ROOT_PATH."/style.css";
			print "<style type=\"text/css\">\n";
			include( ROOT_PATH."style.css" );
			print "</style>\n";
			//print "<link rel=\"stylesheet\" type=\"text/css\" href=\"$style\" />\n";
		}
		print "<script type=\"text/javascript\" src=\"".ROOT_PATH."/scripts.js\"></script>\n";
		
		// Evaluation
		print "<script type=\"text/javascript\" src=\"".ROOT_PATH."/FX_core.js\"></script>\n";
		print "<script type=\"text/javascript\" src=\"".ROOT_PATH."/FX_slide.js\"></script>\n";
		
		print "</head>\n";
		print "<body onload=\"initiation();\">\n";
		print "<noscript>";
		print "<p id=\"enablejavascript\" align=\"center\" style=\"font-size:16pt;color:red;\">";
		print utf8_encode("Bitte aktivieren Sie javascript, um an der Befragung teilnehmen zu knnen!");
		print "</p>";
		print "</noscript>";
		
		print "<table align=\"center\" class=\"page\">\n";
		print "<tr>\n";
		print "<td valign=\"top\" class=\"page\">";
		print "<!-- end ProjectFormatter -->\n";
	}

	function between( &$quest, $i = 0 ){ }

	function behind( &$quest ){
		global $__MESSAGE;
		print "<!-- start ProjectFormatter -->\n";
		print "</td></tr></table>";
		$this->disclaimer();
		print "<script type=\"text/javascript\">\n";
		print "	onLoadHook();\n";
		print "</script>\n";
		//print "<p style=\"font-size:4pt;color:#ffffff;\">".$__MESSAGE."</p>";
		print "</body>\n";
		print "</html>\n";
		print "<!-- end ProjectFormatter -->\n";
	}

	function disclaimer(){
		print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" width=\"200\" style=\"margin-top:40px;border-top:solid 1px #a0a0a0;\">";
		print "<tr>";
		print "<td align=\"center\" style=\"text-align:center;font-family:sans-serif;font-size:7pt;color:#a0a0a0;\">";
		print "Powered by <a style=\"font-weight:normal;font-size:7pt;text-decoration:none;color:#a0a0a0\" href=\"".QTAFI_DOCS."\">online.QTAFI</a>";
		print "</td>";
		print "</tr>";
		print "</table>\n";
	}

	function navigation( &$quest ){
		global $__PAGE;
		print "<table cellpadding=\"5\" class=\"item1\">";
		$num = 1;
		foreach( $quest->document->codebook[0] as $pp => $pa ){
			if( $pp == "Page" ){
				print "<tr>";
				$label = $pa->subject[0];
				if( strlen( $label ) < 1 ) $label = "Page $num";
				if( $num == $__PAGE ){
					print "<td class=\"evenitem1\">".$label."</td>";
				}
				else {
					print "<td class=\"odditem1\"><a href=\"#\" onclick=\"document.qtafi2.__requestpage.value='$num';document.qtafi2.submit();\" >".$label."</a></td>";
				}
				print "</tr>";
				$num++;
			}
		}
		print "</table>";
	}
}
?>