<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats XHTML-Questions
*
*/
class XHTMLFormatter extends StandardFormatter {

	function before(&$quest){
		$this->validator( $quest );
		print "<!-- start XHTMLFormatter -->\n";
		$this->dynamicFilter($quest);
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td>\n";
		$this->head( $quest );
		print "		</td>\n";
		print "	</tr>\n";
		print "	<tr>\n";
		print "		<td class=\"item".$quest->level."\">\n";
		print $quest->xhtml;
		print "		</td>\n";
		print "	</tr>\n";
		
		if($quest->childCount > 0){
			print "<tr>\n";
			print "	<td>\n";
			print "<table width=\"100%\"><tr><td valign=\"top\" class=\"item".($quest->level +1)."\" >\n";
		}
		print "<!-- end XHTMLFormatter -->\n";
	}

	function between(&$quest, $i = 0){ }
	
	function behind(&$quest){
		print "<!-- start XHTMLFormatter -->\n";
		if($quest->childCount > 0){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit($quest);
		print "<!-- end XHTMLFormatter -->\n";
	}
}
?>