<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* <XHTML>
* 	<code>
*		<qtafi:CALL id="A3" />
* 	</code>
* </XHTML>
*
*/
class CALLNode extends InputNode {

	public static $type = "CALL";
	public $value = "1";
	public $hiddenElement = NULL;
	public $inputElement = NULL;
	public $callid = "";

	function __construct( &$doc, &$node, $n ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		
		$this->callid = $node->getAttribute("id");
		$this->htmlElement = $this->document->createElement("div");
		$contentelement = $this->document->createElement("div");
		$contentelement->setAttribute("id",$this->callid);
		
		
		$scriptelement = $this->document->createElement("script");
		$scriptelement->setAttribute("type","text/javascript");
		$sc = $this->document->createTextNode( "asynchronRequest(\"{$this->callid}\");" );
		$scriptelement->appendChild($sc);
		
		$this->htmlElement->appendChild($contentelement);
		$this->htmlElement->appendChild($scriptelement);
		
		$parentNode = $node->parentNode;
		$parentNode->replaceChild($this->htmlElement, $node);
	}

	function setValue( &$vars ){
	}
}

?>