<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Example
*
* <qtafi:QUERY query="select * DATABASE" />
*
* <qtafi:RECORD>
* 	<td><COLUMN name="__n" /></td>
* </qtafi:RECORD>
*
* 
* foreach record
*/
class RECORDNode extends InputNode {

	public static $type = "RECORD";

	function __construct( &$doc, &$node ){
		global $__QUERY_CHANNEL;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$childrenNodes = $node->childNodes;

		$this->htmlElement = $this->document->createElement("span");

		if( isset( $__QUERY_CHANNEL ) ){
			$__count = mysql_num_rows( $__QUERY_CHANNEL );
			if( $__count > 0 ){
				while( $row = mysql_fetch_assoc( $__QUERY_CHANNEL ) ){

					foreach( $childrenNodes as $ch ) $this->htmlElement->appendChild( $ch->cloneNode( true ) );

					$items = $this->htmlElement->getElementsByTagName( "COLUMN" );

					while( $items->length > 0 ){
						$el = $items->item( 0 );
						if( $el->hasAttribute( "name" ) ){
							$parentEl = $el->parentNode;
							$varname = $el->getAttribute("name");
							if( isset( $row[$varname] ) ){
								$vv = html_entity_decode( $row[$varname], ENT_QUOTES, "utf-8" );
								if( $vv == "-9" ) $vv = "";
							}
							else $vv = ".";
							
							$textn = $doc->createTextNode( $vv );
							$spann = $this->document->createElement("span");
							$spann->setAttribute( "id", $varname );
							$spann->appendChild( $textn );
							$parentEl->replaceChild( $spann, $el );
						}
						else{
							$parentEl = $el->parentNode;
							$parentEl->replaceChild( $doc->createTextNode( "empty column" ), $el );
						}
						$items = $this->htmlElement->getElementsByTagName( "COLUMN" );
					}
				}
			}
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){ }
}

?>