<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* prints out a database variable
* <qtafi:VAR variable="A_45" />
* 
* Experimental
* print out php variable:
* <qtafi:VAR sysvariable="__PAGE" />
*
*/
class VARNode extends InputNode {

	public static $type = "VAR";

	function __construct( &$doc, &$node ){
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = NULL;
		
		$this->htmlElement = $this->document->createElement( "span" );
		
		if( $node->hasAttribute( "variable" ) ){
			$this->variable = $node->getAttribute( "variable" );
		}
		
		if( $node->hasAttribute( "sysvariable" ) ){
			$svar = $node->getAttribute( "sysvariable" );
			global $$svar;
			$text = $this->document->createTextNode( $$svar );
			$this->htmlElement->appendChild( $text );
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){
		if( $this->variable != NULL ){
			if( isset( $vars[$this->variable] ) ){
				$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
				$valn = $this->document->createTextNode( $val );
				$this->htmlElement->appendChild( $valn );
			}
		}
	}
}
?>