<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008 Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/
$__STARTTIME = t();
$__PERFORMANCE = dt()."ms start<br/>";

function t(){
	list($usec, $sec) = explode(" ",microtime());
	return (int)(((float)$usec + (float)$sec)*1000); 
}

function dt(){
	global $__STARTTIME;
	$now = (int)t();
	$res = (int)($now-$__STARTTIME);
	$__STARTTIME = $now;
	return $res;
}

include_once "./classes/Formatter.interface.php";
include_once "./classes/composite/FormItem.class.php";
include_once "./classes/Project.class.php";
include_once "./classes/Postprocessor.class.php";
include_once "./classes/Log.class.php";
include_once "./classes/User.class.php";
include_once "./classes/Timing.class.php";
include_once "./classes/StringUtil.class.php";

define("TITLE", "online.QTAFI");
define("CONFIG", ".config");
define("USER", ".user");

$__PROTOCOL = "http://";
if(isset($_SERVER["HTTPS"])) $__PROTOCOL = "https://";

// ***** PATHS **********************************
define("PROJECTS_PATH", "c:/data/htdocs/qtafi/projects");
define("RESOURCES_PATH", "c:/data/htdocs/qtafi/resources");
define("ROOT_PATH", $__PROTOCOL."localhost/qtafi/engine");
define("ONLINE_PROJECTS_PATH", $__PROTOCOL."localhost/qtafi/projects");
define("QTAFI_DOCS", ROOT_PATH."/../../qtafidocs/");

// ***** GLOBAL VARS ****************************
$__MESSAGE = "";
$__ID = 0;
$__DEBUG = false;
$__PAGE = 1;
$__MAX_PAGE = 1;
$__LANGUAGE = "";
$__AUTHOR = "na";
$__AUTHENTICATIONMODE = "pin";//pin/open/poll/request
$__LOGMODE = "normal";//verbose
$__FILE = "";
$__ERROR = 0;
$__ERROR_MESSAGE = "OK";
$page = 1;
$__REQUEST_PAGE = 1;
$project = "";
$__PROJECT = "";
$__IE6 = false;
if(isset($_SERVER['HTTP_USER_AGENT'])) $__IE6 = strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') == true;

$__DEBUG = isset($_GET["debug"])?true:false;

if(isset($_GET["file"])){
	$__FILE = PROJECTS_PATH."/".$_GET["file"];

	$path_parts = pathinfo($__FILE);
	if(substr($path_parts["basename"],0,1) == "."){ //wenn mit . beginnt
		require("url_error.html");
		die();
	}

	if(stristr($_SERVER["PHP_SELF"], "file.php")){
		$filesplited = split("/",$_GET["file"]);
		if(count($filesplited ) == 1){
			$project = $filesplited[count($filesplited)-1];
		}
		elseif(count($filesplited ) == 2){
			$postfix = $filesplited[count($filesplited)-1];
			$__LANGUAGE = $postfix;
			$project = $filesplited[count($filesplited)-2];
		}
		else {
			require("url_error.html");
			die();
		}
	}
	elseif(stristr( $_SERVER["PHP_SELF"], "index.php")){
		//print $_GET["file"];
		$filesplited = split("/",$_GET["file"]);
		if( count( $filesplited ) == 1 ){
			$project = $filesplited[count($filesplited)-1];
			define("QUESTIONNAIRE", ".questionnaire");
		}
		elseif(count( $filesplited ) == 2){
			$postfix = $filesplited[count($filesplited)-1];
			$__LANGUAGE = $postfix;
			$project = $filesplited[count($filesplited)-2];
			if($postfix == "default") define( "QUESTIONNAIRE", ".questionnaire");
			else define("QUESTIONNAIRE", ".questionnaire_".$postfix);
		}
		else {
			require("url_error.html");
			die();
		}
		if(! file_exists( PROJECTS_PATH."/".$project."/".QUESTIONNAIRE ) ){
			require("url_error.html");
			die();
		}
	}
	else {
		$filesplited = split("/",$_GET["file"]);
		if(count($filesplited) == 1 ){
			$project = $filesplited[count($filesplited)-1];
		}
		elseif(count($filesplited) == 2){
			$postfix = $filesplited[count($filesplited)-1];
			$project = $filesplited[count($filesplited)-2];
		}
		else {
			print $_GET["file"];
		}
		die();
	}
}
if(isset($_POST["__page"])) $page = $_POST["__page"];
if(isset($_POST["__requestpage"])) $__REQUEST_PAGE = $_POST["__requestpage"];

//***** GLOBAL VARS ****************************
$__QUERY_CHANNEL = "";
$__ROW_COUNT = -1;
$__COUNTS = array();

// ***** DATABASE *******************************
$db     = "qtafi";
$host   = "localhost";
$login  = "root";
$pw     = "";

define( "SMALL_TYPE", "varchar(10)" );
define( "MEDIUM_TYPE", "varchar(50)" );
define( "TEXT_TYPE", "text" );

$dbHandle = @mysql_connect( $host, $login, $pw ) or die( require( "db_error.html" ) );
define("DB_HANDLE", $dbHandle);
if(! mysql_select_db($db , DB_HANDLE)){
    print "------------------------>firstrun<br>\n";
    mysql_query("create database $db ", DB_HANDLE) or die( "----------------> not succesfull<br>\n".mysql_error() );
    print "------------------------>succesfull<br>\n";
}
// ***** PROJEKTZUWEISUNG ***********************
define("PROJECT", $project);

// ***** PAGE ***********************************
if($page < 0) $page = 1;
$__PAGE = $page;

// ***** DATABASE TABLES ************************
define("DATABASE", PROJECT."_db");
define("LOG_DATABASE", PROJECT."_log");
define("ADMIN_DATABASE", "admin_db");
define("ADMIN_LOGDATABASE", "admin_log");

// ***** PROJECT PATH ***************************
define("PROJECT_PATH", PROJECTS_PATH."/".PROJECT."/");

// ***** MISSING ********************************
define("MISSING", "-9");

// ***** KONFIGURATION **************************
$__START = 0;
$__END = 0;
$__SOURCE = "-9";
$__AUTHENTICATIONMODE = "pin";
$__LOGMODE = "normal";

if( file_exists( PROJECT_PATH.CONFIG ) ){
	$configuration = simplexml_load_file( PROJECT_PATH.CONFIG );
	foreach( $configuration->config[0] as $tag => $v ){
		switch( $tag ){
			case "start" :
				define("START", Timing::parseTime( (string)$v));
				$__START = Timing::parseTime((string)$v);
			break;
			case "end":
				$ee = Timing::parseTime((string)$v);
				if($ee == 0) $ee = 9999999900;
				define("END", $ee);
				$__END = $ee;
			break;
			case "author":
				define("AUTHOR", (string)$v);
				$__AUTHOR = (string)$v;
			break;
			case "authentication":
				define("AUTHENTICATION", (string)$v);
				$__AUTHENTICATIONMODE = (string)$v;
				$__MESSAGE .= "authen: ".(string)$v;
			break;
			case "log":
				$__LOGMODE = (string)$v;
			break;
			case "statistic":
				$__LOGMODE = (string)$v;
			break;
		}
	}
}
else{
	$__ERROR_MESSAGE = "no configuration file";
	$__ERROR = 2;
}
// ***** ERRORS *********************************
define("ERROR_OK", 0); //no error
define("ERROR_AUTHENTICATION", 1);
define("ERROR_CONFIG", 2);
define("ERROR_DOUBLE_USER", 3);
define("ERROR_UNKNOWN", 99);

?>