<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include "config.php";

$path_parts = pathinfo($__FILE);

$user = new User();
if( isset( $_POST["__id"] ) ){
	$stat = new Log();
	$user->authenticate( $_POST );
	$stat->write();
	$user->write( $_POST );
}
if( isset( $_GET["logout"] ) ){
	$user->logout( $_POST );
}

if( substr( $path_parts["basename"],0,1) == "." ){
	require( "url_error.html" );
	die();
}

if( ! file_exists( $__FILE ) ) {
	print $__FILE." not exists";
	die();
}
//print "extension: ".$path_parts["extension"];

if( $path_parts["extension"] == "css" ) header('Content-type: text/css');
if( $path_parts["extension"] == "pdf" ) header('Content-type: application/pdf');
if( $path_parts["extension"] == "jar" ){
	header('Accept-Ranges: bytes');
	$b = filesize( $__FILE );
	header('Content-length: '.$b );
	header('Content-type: text/plain');
}
if( $path_parts["extension"] == "jnlp" ){
	header('Accept-Ranges: bytes');
	$b = filesize( $__FILE );
	header('Content-length: '.$b );
	header('Content-type: application/x-java-jnlp-file');
}
else if( $path_parts["extension"] == "survey" ){
	$user = new User();
	$stat = new Statistic();
	if( isset( $_POST["__id"] ) ){
		$user->authenticate( $_POST );
		$stat->write();
		$user->write( $_POST );
	}

	if( isset( $_GET["logout"] ) ){
		$user->logout( $_POST );
	}
	$disablePP = isset( $_GET["disablepostprocessor"] )?true:false;
	if( ! $disablePP ) {
		$post = new Postprocessor();
		$post->processFile( $__FILE );
		$vars = $post->getVariables();
		$user->read( $vars );
		$user->writeMeta();
		$post->setVariables( $vars );
		echo $post->toScreen();
		return;
	}
}

readfile( $__FILE );
if( @defined( DB_HANDLE ) ) mysql_close( DB_HANDLE );
?>