<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include_once "config.php";
include_once "./classes/Administrator.class.php";
include_once "./classes/AdministratorLog.class.php";

$admin = new Administrator();
if( isset( $_POST["__pin"] ) && isset( $_POST["__id"] ) && isset( $_POST["__name"] )) $admin->authenticate( $_POST );
else $admin->authenticate( $_GET );

$log = new AdministratorLog();
$log->write();
if( $log->isBlocked() ){
?>
<html>
<head>
<title>online.QTAFI - Administration - <?=$__PROJECT ?></title>
<link rel="stylesheet" type="text/css" href="<? print ROOT_PATH."/style.css"; ?>"></link>
<link rel="shortcut icon"  href="<? print ROOT_PATH."/images/icon.png"; ?>"</link>
</head>
<body style="background-image:url(./images/gradient.png);background-position:right top;background-repeat:repeat-y">
<h1>Error - Please contact the administator</h1>
</body>
</html>
<?
	die();
}

$database = $__PROJECT."_db";
$log_database = $__PROJECT."_log";
//$discuss_database = $__PROJECT."_discuss";

if( isset( $_GET["adminAction"] ) && isset( $_GET["value"]) ){
	$v = htmlentities( $_GET["value"]);
	switch( $_GET["adminAction"] ){
		case "logout": {
			$admin->logout( $_GET );
			break;
		}
	}
}

?>
<html>
<head>
<title>online.QTAFI - Administration - <?=$__PROJECT ?></title>
<link rel="stylesheet" type="text/css" href="<? print ROOT_PATH."/style.css"; ?>"></link>
<link rel="shortcut icon"  href="<? print ROOT_PATH."/images/icon.png"; ?>"</link>
<script type="text/javascript">
function changeValue(vari, row, old, id, project ){
	var val = prompt( "Value", old );
	if( val != null ){
		window.location.href = "?__id="+id+"&__project="+project+"&tableAction=changeValue&row="+row+"&variable="+vari+"&value="+escape(val);
	}
}

function confirmAndFulfill(id, project, action, value){
	var proceed = confirm( "Do you realy want to do " + action + "?" );
	if( proceed == true ){
		window.location.href = "?__id="+id+"&__project="+project+"&tableAction="+action+"&value="+value;
	}
}

function changePassword(vari, row, old, id, project){
	var val = prompt( "New password: ");
	if( val != null ){
		window.location.href = "?__id="+id+"&__project="+project+"&tableAction=changePassword&row="+row+"&value="+escape(val);
	}
}

</script>
</head>
<body style="background-image:url(./images/gradient.png);background-position:right top;background-repeat:repeat-y">
<?
if( $__AUTHENTICATION != "authenticated" ){
	print "<h1>QTAFI Administrator Login</h1>";
	print "<form method=\"post\" action=\"admin.php\">";
	print "<input type=\"hidden\" name=\"__id\" value=\"$__ID\" ></input>";
	print "<table>";
	print "<tr><td>Name:</td><td><input type=\"text\" name=\"__name\" size=\"8\"></input></td></tr>";
	print "<tr><td>Password:</td><td><input type=\"password\" name=\"__pin\" size=\"8\"></input></td></tr>";
	print "<tr><td><input type=\"submit\" value=\"Login\"></input></td>";
	print "<td><input type=\"reset\" value=\"Cancel\" ></input></td>";
	print "</table>";
	print "</form>";
	die();
}
else{
?>
<h1>Data</h1>
<table cellspacing="5" class="toolbox">
<tr>
<td>
	<input type="button" onClick="document.location.href='?__id=<?= $__ID ?>&__project=<?=$__PROJECT ?>&adminAction=logout&value=empty'" value="Logoff" />
</td>
<td>
	<input type="button" onClick="document.location.href='?__id=<?= $__ID ?>&__project=<?=$__PROJECT ?>'" value="Refresh" />
</td>
<td>
	<form method="post" action="<? print ROOT_PATH."/request.php"; ?>" >
	<input type="hidden" name="__id" value="<?=$__ID ?>" />
	<input type="hidden" name="__project" value="<?=$__PROJECT ?>" />
	<input type="hidden" name="requestAction" value="getData" />
	<input type="hidden" name="value" value="data" />
	<input type="submit" value="Download Data" />
	</form>
</td>
<td>
	<form method="post" action="<? print ROOT_PATH."/request.php"; ?>" >
	<input type="hidden" name="__id" value="<?=$__ID ?>" />
	<input type="hidden" name="__project" value="<?=$__PROJECT ?>" />
	<input type="hidden" name="requestAction" value="getTxtData" />
	<input type="hidden" name="value" value="data" />
	<input type="submit" value="Download TXT Data" />
	</form>
</td>
<td>
	<input type="button" onClick="confirmAndFulfill( '<?=$__ID ?>', '<?=$__PROJECT ?>', 'deleteTable', 'table' );" value="Delete Table" />
</td>
<td>
	<form method="get" >
	<input type="hidden" name="tableAction" value="addRow"></input>
	<input type="hidden" name="value" value="12345"></input>
	<input type="hidden" name="__id" value="<?=$__ID ?>"></input>
	<input type="hidden" name="__project" value="<?=$__PROJECT ?>" />
	<input type="submit" value="Append New Case"></input>
	</form>
</td>
</tr>
</table>
<?
}

$sortString = "";
$direction = "";
$result = @mysql_query( "select * from ".$database." $sortString $direction", DB_HANDLE );

if( isset( $_GET["tableAction"] ) && isset( $_GET["value"]) ){
	$v = htmlentities( $_GET["value"]);
	switch( $_GET["tableAction"] ){
		case "deleteTable" : deleteTable( $v ); break;
		case "deleteVariable" : deleteVariable( $v ); break;
		case "deleteLog" : deleteLog( $v ); break;
		case "deleteRow" : deleteRow( $v ); break;
		case "changeValue" : changeValue( $v ); break;
		case "sortBy" : sortBy( $v ); break;
		case "addRow" : addRow( $v ); break;
		case "clearDiscussion" : clearDiscussion( $v ); break;
		case "changePassword" : changePassword( $v ); break;
	}
}

function changePassword( $v ){
	global $_GET,$result, $direction, $sortString,$database;
	$passhash = mysql_real_escape_string(base64_encode(crypt($v)));
	$row = -1;
	if(isset($_GET["row"])) $row = $_GET["row"];
	if($row > 0) mysql_query("update ".$database." set __pin=\"{$passhash}\", __lastchange=CURRENT_TIMESTAMP where __n=\"{$row}\" ", DB_HANDLE ) or die( "changeValue() error".$v );
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE) or die("error" );
}

function deleteVariable($v){ 
	global $result, $direction, $sortString,$database;
	mysql_query("alter table ".$database." drop $v ") or die( "error:deleteVariable ".mysql_error());
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE) or die("deleteVariable() error" );
}

function deleteTable($v){
	global $result, $direction, $sortString,$database;
	if($__PROJECT == "admin") mysql_query( "drop table ".ADMIN_DATABASE." ") or die("error:dropTable ".mysql_error() );
	else mysql_query("drop table ".$database." ") or die( "error:dropTable ".mysql_error());
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE) or die("deleteTable() error" );
}

function clearDiscussion($v){
	global $discuss_database;
	mysql_query("drop table ".$discuss_database." ") or die("error:clearDiscussTable ".mysql_error() );
}

function deleteLog($v){ 
	global $result,$direction,$sortString,$database,$log_database,$__PROJECT;
	if($__PROJECT == "admin") mysql_query( "drop table ".ADMIN_LOGDATABASE, DB_HANDLE);
	else mysql_query("drop table ".$log_database, DB_HANDLE) or die("error:dropLogTable ".mysql_error() );
}

function sortBy($v){ 
	global $_GET,$result, $direction, $sortString, $database;
	$d = "";
	if(isset($_GET["direction"])) $d = $_GET["direction"] ? "" : "DESC";
	$direction = $d;
	$sortString = "ORDER BY {$v} ";
	print "select * from ".$database." {$sortString} {$direction} ";
	$result = mysql_query("select * from ".$database." {$sortString} {$direction} ", DB_HANDLE) or die( "sortBy() error" );
}

function deleteRow($i){ 
	global $result, $direction, $sortString,$database;
	mysql_query("delete from ".$database." where __n=\"$i\"") or die("error:deleteRow ".mysql_error() );
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE) or die( "deleteRow() error" );
}

function changeValue($v){
	global $_GET, $result, $direction, $sortString, $database;
	$row = -1;
	//$v = mysql_real_escape_string( $v );
	if(isset($_GET["row"])) $row = $_GET["row"];
	if(isset($_GET["variable"]) && $row > 0){
		$variable = $_GET["variable"];
		mysql_query("update ".$database." set $variable=\"{$v}\", __lastchange=CURRENT_TIMESTAMP where __n=\"$row\" ", DB_HANDLE ) or die( "changeValue() error".$v );
	}
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE ) or die( "error" );
}

function addRow($pin){
	global $result, $direction, $sortString,$database;
	$pinhash = mysql_real_escape_string(base64_encode(crypt($pin)));
	mysql_query("insert into ".$database." ( __pin, __id, __inited ) values ( \"{$pinhash}\" ,\"0\", CURRENT_TIMESTAMP )" ) or die( "addRow() error" );
	$result = mysql_query("select * from ".$database." $sortString $direction", DB_HANDLE) or die( "addRow() error" );
}

print "<table cellspacing=\"0\" cellpadding=\"4\" class=\"data\">";
if( ! $result ){
	print "<tr><td>empty table</td></tr>";
}
else {
	$i = 1;
	$vars = array();
	while( $arr = mysql_fetch_assoc($result)){
		$num = $arr["__n"];
		if($i == 1){//header
			print "<tr>";
			print "<th>Num</th>";
			foreach( $arr as $n => $v ){
				array_push( $vars, $n );
				print "<th class=\"data\"><a href=\"?__id={$__ID}&__project={$__PROJECT}&tableAction=sortBy&value={$n}&direction={$direction}\">$n</a>";
				//print "&nbsp;<a href=\"javascript:confirmAndFulfill('{$__ID}','{$__PROJECT}','deleteVariable','{$n}');\"><img src=\"".ROOT_PATH."/images/delete_variable.gif\" border=\"0\"/></a>";
				print "</th>";
			}
			print "</tr>";
		}
		print "<tr>";
		print "<td class=\"data\"><a href=\"javascript:confirmAndFulfill('{$__ID}','{$__PROJECT}','deleteRow','{$num}');\">$i</a></td>";
		foreach( $vars as $n ){
			$vv = "";
			if(isset($arr[$n])) $vv = $arr[$n];
			if($n == "__n") print "<td class=\"data\">$vv</td>";
			else if($n == "__pin" && $__PROJECT == "admin"){
				print "<td class=\"data\"><a href=\"javascript:changeValue('$n', '$num', '$vv', '$__ID', '$__PROJECT' );\">$vv</a>";
				print "|<a href=\"javascript:changePassword('$n','$num','$vv','$__ID','$__PROJECT');\">SET</a>";
				print "</td>";
			}
			else {
				if(mb_strlen( $vv ) == 0){
					print "<td class=\"data\"><a href=\"javascript:changeValue('$n', '$num', '$vv', '$__ID', '$__PROJECT' );\">[empty]</a></td>";
				}
				else print "<td class=\"data\"><a href=\"javascript:changeValue('$n', '$num', '$vv', '$__ID', '$__PROJECT' );\">$vv</a></td>";
			}
		}
		print "</tr>";
		$i++;
	}
}
print "</table>";
print "<br><br>";
?>
<? /********* Log Table *****************/ ?>
<h1>Log</h1>
<table cellspacing="5" class="toolbox">
	<tr>
		<td>
			<form method="post" action="<? print ROOT_PATH."/request.php"; ?>" >
			<input type="hidden" name="__id" value="<?=$__ID ?>" />
			<input type="hidden" name="__project" value="<?=$__PROJECT ?>" />
			<input type="hidden" name="requestAction" value="getStatistic" />
			<input type="hidden" name="value" value="data" /> 
			<input type="submit" value="Download Log" />
			</form>
		</td>
		<td>
			<input type="button" onClick="confirmAndFulfill('<?=$__ID ?>','<?=$__PROJECT ?>','deleteLog',' ' );" value="Clear Log" />
		</td>
	</tr>
</table>
<table cellspacing="0" cellpadding="4" class="data">
	<tr>
		<th>n</th>
		<th>Requestpage</th>
		<th>Writepage</th>
		
		<th>Requesttime</th>
		<th>Writetime</th>
		
		<th>Status</th>
		<th>IP</th>
		
		<th>GET</th>
		<th>POST</th>
		
		<th>Advanced</th>
	</tr>
	
<?
if( $__PROJECT == "admin" ){
	$result = @mysql_query( "select * from ".ADMIN_LOGDATABASE." " , DB_HANDLE );
}
else $result = @mysql_query( "select * from ".$log_database." " , DB_HANDLE );
if( ! $result ){
	print "<tr><td colspan=\"10\">empty table</td></tr>";
}
elseif( mysql_num_rows( $result ) > 0 ){
	while( $row = mysql_fetch_assoc( $result ) ){
		print "<tr>\n";
		print "<td class=\"data\">".$row["n"]."</td>\n";
		
		print "<td class=\"data\">".$row["requestpage"]."</td>\n";
		print "<td class=\"data\">".$row["writepage"]."</td>\n";
		
		print "<td class=\"data\">".$row["requesttime"]."</td>\n";
		print "<td class=\"data\">".$row["writetime"]."</td>\n";
		
		print "<td class=\"data\">".$row["status"]."</td>\n";
		print "<td class=\"data\">".$row["ip"]."</td>\n";
		
		print "<td class=\"data\">".(strlen($row["get"])<1?"-":$row["get"])." </td>\n";
		print "<td class=\"data\">".(strlen($row["post"])<1?"-":$row["post"])." </td>\n";
		
		print "<td class=\"data\">".(strlen($row["advanced"])<1?"-":$row["advanced"])."</td>\n";
		print "</tr>\n";
	}
}
?>
</table>

<? if( @defined( DB_HANDLE) ) mysql_close( DB_HANDLE ); ?>
</body>
