<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class Timing {

	/**
	* DD.MM.YY
	*/
    static function parseTime( $str ){
    	if( strlen( $str ) < 7 ) return 0;
        list( $dd, $mm, $yy ) = split( '[/.-]', $str );
        return mktime( 0, 0, 0, $mm, $dd, $yy );
    }

    static function currentTime( ){
        return time();
    }

    static function formatTime( $i = -1 ){
        if( $i == -1 ) $i = time();
        return date( "d.m.y", $i );
    }
}
?>