<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Page
*
* <Page>
*    	<children/>
* </Page>
*/
class Page extends FormItem {

	public $footer;
	public $header;
	public $pagewidth = 800;
	public $href = "";

	function __construct(){
		parent::__construct();
		$this->type = "Page";
		$this->footer = new Foot();
		$this->header = new Head();
		$this->formatterclass = "PageFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		$att = $doc->attributes();

		if( isset( $att["pagewidth"] ) ){
			$this->pagewidth = (int)$att["pagewidth"];
		}
		if( isset( $att["href"] ) ){
			$this->href = utf8_decode( $att["href"] );
		}
	}
}
?>