<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
*
* <XHTML>
*    <text>Question</text>
*    <subject></subject>
*    <variable></variable>
*    <code>
*      <h1>XXX</h1>
*    </code>
* </XHTML>
*/
class XHTML extends FormItem {

	public $xhtml = "";

	function __construct(){
		parent::__construct();
		$this->type = "XHTML";
		$this->formatterclass = "XHTMLFormatter";
	}

	function readXML(&$doc){
		parent::readXML($doc);
		foreach($doc as $n => $v){
			switch($n){
				case "code":
					$this->xhtml = $v->asXML();
					$this->xhtml = str_replace("</code>", "", $this->xhtml);
					$this->xhtml = ereg_replace("<code[^>]*>", "", $this->xhtml);
					$this->xhtml = str_replace("{VARIABLE_PREFIX}", $this->variableprefix, $this->xhtml);
				break;
			}
		}
	}
}

?>
