<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats the navigation buttons
*
*/
class NavigationButtonFormatter extends StandardFormatter {

	function before( &$quest ){
		global $__PAGE, $__MAX_PAGE,$__ID;
		print "<!-- start NavigationButtonFormatter -->\n";
		print "<table width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"3\" cellspacing=\"0\" >\n";
		print "    <tr>\n";
		if( $__PAGE > 1 ){
			if(FormItem::$direction == "rtl"){
				print "        <td class=\"item".$quest->level."\" style=\"text-align:right;\" align=\"right\">\n";
				print "			<input type=\"submit\" onClick=\"document.qtafi2.action='./';document.qtafi2.target='_self';document.qtafi2.__requestpage.value=parseInt(document.qtafi2.__page.value)-1;\" value=\"".$quest->backwardlabel."\" />\n";
				print "        </td>\n";
			}
			else {
				print "        <td class=\"item".$quest->level."\" style=\"text-align:left;\" align=\"left\">\n";
				print "			<input type=\"submit\" onClick=\"document.qtafi2.action='./';document.qtafi2.target='_self';document.qtafi2.__requestpage.value=parseInt(document.qtafi2.__page.value)-1;\" value=\"".$quest->backwardlabel."\" />\n";
				print "        </td>\n";
			}
		}
		if( $quest->childCount > 0 ){
			print "<td>";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
	}

	function between( &$quest, $i = 0 ){
	}

	function behind( &$quest ){
		global $__PAGE, $__MAX_PAGE,$__ID;
		if( $quest->childCount > 0 ){
			print "</td></tr></table>\n";
			print "</td>";
		}
		if( $__PAGE < $__MAX_PAGE ){
			if(FormItem::$direction == "rtl"){
				print "        <td class=\"item".$quest->level."\" style=\"text-align:left;\" align=\"left\">\n";
				print "			<input type=\"submit\" onClick=\"document.qtafi2.action='./';document.qtafi2.target='_self';document.qtafi2.__requestpage.value=parseInt(document.qtafi2.__page.value)+1;\" value=\"".$quest->forwardlabel."\" />\n";
				print "        </td>\n";
			}
			else {
				print "        <td class=\"item".$quest->level."\" style=\"text-align:right;\" align=\"right\">\n";
				print "			<input type=\"submit\" onClick=\"document.qtafi2.action='./';document.qtafi2.target='_self';document.qtafi2.__requestpage.value=parseInt(document.qtafi2.__page.value)+1;\" value=\"".$quest->forwardlabel."\" />\n";
				print "        </td>\n";
			}
		}

		print "    </tr>\n";
		print "</table>\n";
		print "<!-- end NavigationButtonFormatter -->\n";
	}
}
?>