<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class PageFormatter extends StandardFormatter {

	function before( &$quest ){
		global $__PAGE, $__MAX_PAGE,$__ID, $__DEBUG;
		print "<!-- start PageFormatter -->\n";
		if( $__DEBUG ){
			print "<small>".$quest->id;
			if( count($quest->filter) > 0 ){
				print "<br/>filter:";
				foreach( $quest->filter as $ignore ) print $ignore["variable"]." ".$ignore["operator"]." ".$ignore["value"];
			}
			print "</small>";
		}

		//print "<center>\n";
		print "<table align=\"center\" class=\"item0\" width=\"".$quest->pagewidth."\" cellpadding=\"0\" cellspacing=\"0\">\n";
		print "    <tr>\n";
		print "        <td>\n";
		print "            <form method=\"post\" action=\"\" name=\"qtafi2\" accept-charset=\"UTF-8\" onSubmit=\"return onFormSubmit();\">\n";
		print "                 <input type=\"hidden\" name=\"__page\" value=\"".$__PAGE."\"></input>\n";
		print "                 <input type=\"hidden\" name=\"__requestpage\" value=\"".$__PAGE."\"></input>\n";
		print "                 <input type=\"hidden\" name=\"__timestamp\" value=\"".time()."\"></input>\n";
		print "                 <input type=\"hidden\" name=\"__project\" value=\"".PROJECT."\"></input>\n";
		print "                 <input type=\"hidden\" name=\"__id\" value=\"".$__ID."\"></input>\n";
		foreach( $quest->variables as $n => $v ){
			print "                 <input type=\"hidden\" name=\"$n\" value=\"$v\"></input>\n";
		}

		print "            <table class=\"item0\" width=\"100%\" cellpadding=\"5\" cellspacing=\"0\">\n";

		if( ! $quest->header->empty ){
			print "                <tr>\n";
			if( $quest->layout == "horizontal" ){
				print "<td class=\"header0\" colspan=\"".$quest->childCount."\">\n";
			}
			else print "                    <td class=\"header0\">\n";
			$quest->header->format();
			print "               	 </td>\n";
			print "               </tr>\n";
		}

		print "                <tr>\n";
		print "                    <td class=\"item0\" valign=\"top\">\n";
		if( strlen( $quest->href ) > 1 ) {
			//foreach( file( PROJECT_PATH.$quest->href ) as $l) print $l;
			readfile( PROJECT_PATH.$quest->href );
			//require( PROJECT_PATH.$quest->href );
		}
		print "<!-- end PageFormatter -->\n";
	}

	function between( &$quest, $i = 0 ){
 		print "<!-- start PageFormatter -->\n";
		if( $quest->layout == "horizontal" ){
			print "        </td>\n";
			print "        <td valign=\"top\">\n";
		}
		else{
			print "        </td>\n";
			print "    </tr>\n";
			print "    <tr>\n";
			print "        <td>\n";
		}
		print "<!-- end PageFormatter -->\n";
	}

	function behind( &$quest ){
		print "<!-- start PageFormatter -->\n";
		print "                    </td>\n";
		print "                 </tr>\n";
		if( ! $quest->footer->empty ){
			print "                 <tr>\n";
			if( $quest->layout == "horizontal" ){
				print "<td class=\"footer0\" colspan=\"".$quest->childCount."\">\n";
			}
			else print "                    <td class=\"footer0\">\n";

			$quest->footer->format();
			print "                    </td>\n";
			print "                </tr>\n";
		}
		print "            </table>\n";
        print "            </form>\n";
        print "        </td>\n";
        print "    </tr>\n";
		print "</table>\n";
		//print "</center>\n";
        print "<!-- end PageFormatter -->\n";
    }
}
?>