<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats the ProgressBar
*
*/
class ProgressBarFormatter extends StandardFormatter {

	function before( &$quest ){
		global $__PAGE, $__MAX_PAGE,$__ID;
		print "<!-- start ProgressBarFormatter -->\n";
		
		switch( $quest->bartype ){
		
		case "numeric":
			print "<table width=\"100%\" class=\"progressbar".$quest->level."\" cellpadding=\"3\" cellspacing=\"0\" >\n";
			print "    <tr>\n";
			print "        <td class=\"progressbar".$quest->level."\" style=\"text-align:center;\" align=\"center\">\n";
			print "			<span>$__PAGE / $__MAX_PAGE</span>\n";
			print "        </td>\n";
			print "    </tr>\n";
			print "</table>\n";
			break;
		
		case "bar" :
			$val = intval($__PAGE/$__MAX_PAGE* $quest->length);
			$bg = $quest->backgroundcolor;
			$c1 = $quest->color1;
			$c2 = $quest->color2;
			$mes = "Page $__PAGE / $__MAX_PAGE";
			print "<table width=\"100%\" class=\"progressbar".$quest->level."\" cellpadding=\"3\" cellspacing=\"0\" >\n";
			print "    <tr>\n";
			print "        <td class=\"progressbar".$quest->level."\" style=\"text-align:center\" align=\"center\">\n";
			//print "			<img src=\"".ROOT_PATH."/chart.php?value=$val&width={$quest->length}&height={$quest->size}&gradient=double&background=$bg&color1=$c1&color2=$c2\" title=\"$mes\"></img>\n";
			print "			<img src=\"".ROOT_PATH."/chart.php?value=$val&amp;width={$quest->length}&amp;height={$quest->size}&amp;gradient=double&amp;background=$bg&amp;color1=$c1&amp;color2=$c2\" title=\"$mes\"></img>\n";
			print "        </td>\n";
			print "    </tr>\n";
			print "</table>\n";
		}
		print "<!-- end ProgressBarFormatter -->\n";
	}

	function between( &$quest, $i = 0 ){ }

	function behind( &$quest ){ }
}
?>