<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class REFormatter extends StandardFormatter {

    function before( &$quest ){
        $cols = 1;
        if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		$this->validator( $quest );
        print "<!-- start REFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td>\n";
		$this->head( $quest );
		print "		</td>\n";
		print "	</tr>\n";

		if( strlen( $quest->remark ) > 1 ){
			print "	<tr>\n";
			print "		<td class=\"item".$quest->level."\">\n";
			print $quest->remark."\n";
			print "		</td>\n";
			print "	</tr>\n";
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td valign=\"top\">\n";
			//print "<table width=\"100%\" cellspacing=\"5\" cellpadding=\"0\">\n";
			print "<table cellspacing=\"5\" cellpadding=\"0\">\n";
			print "<tr><td valign=\"top\" class=\"item".($quest->level +1)."\">\n";
		}
        print "<!-- end REFormatter -->\n";
    }

	function behind( &$quest ){
		$questnum = $quest->nr;
		print "<!-- start REFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit( $quest );
		print "<!-- end REFormatter -->\n";
    }
}
?>