<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Example
*
* <qtafi:QUERY query="select * DATABASE" />
*
* <qtafi:COUNT id="dd" /> -> <span id="dd" >{val}</span>
*
*/
class COUNTNode extends InputNode {

	public static $type = "COUNT";

	function __construct( &$doc, &$node ){
		global $__QUERY_CHANNEL;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$childrenNodes = $node->childNodes;
		$this->htmlElement = $this->document->createElement("span");

		if( isset( $__QUERY_CHANNEL ) ){
			$__count = mysql_num_rows( $__QUERY_CHANNEL );
			$tn = $doc->createTextNode( $__count );
			$this->htmlElement->appendChild( $tn );
			if( $node->hasAttribute( "id" ) ){
				$idn = $node->getAttribute( "id" );
				$this->htmlElement->setAttribute( "id", $idn );
			}
		}
		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}
	function setValue( &$vars ){ }
}

?>