<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include "config.php";
$user = new User();
$log = new Log();
$log->block();
$disablePP = isset( $_GET["disablepostprocessor"] )?true:false;

if(isset($_POST["__id"])){
	$user->authenticate($_POST);
	$log->write();
	$user->write($_POST);
}

if( isset($_GET["logout"])){
	$user->logout($_POST);
}

$post = new Postprocessor();

if( ! $disablePP ) ob_start();
$p = new Project();
if(isset($_GET["ref"])){
	$p->buildReference($_GET["ref"]);
	$p->format();
}
elseif(isset($_GET["asynchronrequest"])){
	FormItem::$ccc = 50;
	$p->searchReference($_GET["asynchronrequest"]);
	$p->formatElement();
}
else{
	$p->buildPage();
	$p->format();
}

if(! $disablePP) {
	$post->processContent(ob_get_contents());
	ob_clean();
	$vars = $post->getVariables();
	$user->read($vars);
	$user->writeMeta();
	$post->setVariables($vars);
	echo $post->toScreen();
}
mysql_close(DB_HANDLE);
?>